//   Copyright 2012 Georg-August-Universität Göttingen, Germany
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.

package de.ugoe.cs.autoquest.plugin.html.guimodel;

/**
 * <p>
 * TODO comment
 * </p>
 * 
 * @author Patrick Harms
 */
public class HTMLPageElement extends HTMLGUIElement {

    /**  */
    private static final long serialVersionUID = 1L;

    /**
     * <p>
     * TODO: comment
     * </p>
     *
     * @param specification
     * @param parent
     */
    public HTMLPageElement(HTMLPageElementSpec specification, HTMLGUIElement parent) {
        super(specification, parent);
    }

    /**
     * <p>
     * TODO: comment
     * </p>
     *
     * @param specification
     * @param parent
     */
    public HTMLPageElement(HTMLPageElementSpec specification, HTMLDocument parent) {
        super(specification, parent);
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        String str = getTagName();
        
        if ((getHtmlId() != null) && (!"".equals(getHtmlId()))) {
            str += "(id=\"" + getHtmlId() + "\")";
        }
        else {
            str += "[" + getIndex() + "]";
        }
        
        return str;
    }

    /*
     * (non-Javadoc)
     * 
     * @see de.ugoe.cs.autoquest.plugin.html.guimodel.HTMLGUIElement#getElementDescriptor()
     */
    @Override
    protected String getElementDescriptor() {
        return getTagName();
    }

    /**
     * <p>
     * TODO: comment
     * </p>
     *
     * @return
     */
    HTMLDocumentSpec getPage() {
        return ((HTMLPageElementSpec) super.getSpecification()).getPage();
    }

    /**
     * <p>
     * TODO: comment
     * </p>
     *
     * @return
     */
    String getTagName() {
        return ((HTMLPageElementSpec) super.getSpecification()).getTagName();
    }

    /**
     * <p>
     * TODO: comment
     * </p>
     *
     * @return
     */
    String getHtmlId() {
        return ((HTMLPageElementSpec) super.getSpecification()).getHtmlId();
    }

    /**
     * <p>
     * TODO: comment
     * </p>
     *
     * @return
     */
    int getIndex() {
        return ((HTMLPageElementSpec) super.getSpecification()).getIndex();
    }

}
